diff --git a/orocos_kdl/src/chainiksolver.hpp b/orocos_kdl/src/chainiksolver.hpp
index 4daed84..2bb1572 100644
--- a/orocos_kdl/src/chainiksolver.hpp
+++ b/orocos_kdl/src/chainiksolver.hpp
@@ -29,6 +29,7 @@
 #include "jntarray.hpp"
 #include "jntarrayvel.hpp"
 #include "jntarrayacc.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -38,7 +39,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverPos {
+    class KDL_EXPORT ChainIkSolverPos {
     public:
         /**
          * Calculate inverse position kinematics, from cartesian
@@ -61,7 +62,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverVel {
+    class KDL_EXPORT ChainIkSolverVel {
     public:
         /**
          * Calculate inverse velocity kinematics, from joint positions
@@ -97,7 +98,7 @@ namespace KDL {
      * @ingroup KinematicFamily
      */
 
-    class ChainIkSolverAcc {
+    class KDL_EXPORT ChainIkSolverAcc {
     public:
         /**
          * Calculate inverse acceleration kinematics from joint
diff --git a/orocos_kdl/src/chainiksolverpos_lma.hpp b/orocos_kdl/src/chainiksolverpos_lma.hpp
index 842a9c0..06bc00e 100644
--- a/orocos_kdl/src/chainiksolverpos_lma.hpp
+++ b/orocos_kdl/src/chainiksolverpos_lma.hpp
@@ -33,6 +33,7 @@
 
 #include "chainiksolver.hpp"
 #include "chain.hpp"
+#include "kdl_export.hpp"
 #include <Eigen/Dense>
 
 namespace KDL
@@ -61,7 +62,7 @@ namespace KDL
 
  * \ingroup KinematicFamily
  */
-class ChainIkSolverPos_LMA : public KDL::ChainIkSolverPos
+class KDL_EXPORT ChainIkSolverPos_LMA : public KDL::ChainIkSolverPos
 {
 private:
 	typedef double ScalarType;
diff --git a/orocos_kdl/src/chainiksolverpos_nr.hpp b/orocos_kdl/src/chainiksolverpos_nr.hpp
index f49ff9a..ed0dfb6 100644
--- a/orocos_kdl/src/chainiksolverpos_nr.hpp
+++ b/orocos_kdl/src/chainiksolverpos_nr.hpp
@@ -24,6 +24,7 @@
 
 #include "chainiksolver.hpp"
 #include "chainfksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -35,7 +36,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverPos_NR : public ChainIkSolverPos
+    class KDL_EXPORT ChainIkSolverPos_NR : public ChainIkSolverPos
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainiksolverpos_nr_jl.hpp b/orocos_kdl/src/chainiksolverpos_nr_jl.hpp
index 9d42945..a3cee5c 100644
--- a/orocos_kdl/src/chainiksolverpos_nr_jl.hpp
+++ b/orocos_kdl/src/chainiksolverpos_nr_jl.hpp
@@ -26,6 +26,7 @@
 
 #include "chainiksolver.hpp"
 #include "chainfksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -37,7 +38,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverPos_NR_JL : public ChainIkSolverPos
+    class KDL_EXPORT ChainIkSolverPos_NR_JL : public ChainIkSolverPos
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainiksolvervel_pinv.hpp b/orocos_kdl/src/chainiksolvervel_pinv.hpp
index 37b4c77..f998360 100644
--- a/orocos_kdl/src/chainiksolvervel_pinv.hpp
+++ b/orocos_kdl/src/chainiksolvervel_pinv.hpp
@@ -25,6 +25,7 @@
 #include "chainiksolver.hpp"
 #include "chainjnttojacsolver.hpp"
 #include "utilities/svd_HH.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -37,7 +38,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverVel_pinv : public ChainIkSolverVel
+    class KDL_EXPORT ChainIkSolverVel_pinv : public ChainIkSolverVel
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainiksolvervel_pinv_givens.hpp b/orocos_kdl/src/chainiksolvervel_pinv_givens.hpp
index 04b1e0b..9e2a668 100644
--- a/orocos_kdl/src/chainiksolvervel_pinv_givens.hpp
+++ b/orocos_kdl/src/chainiksolvervel_pinv_givens.hpp
@@ -5,6 +5,7 @@
 
 #include "chainiksolver.hpp"
 #include "chainjnttojacsolver.hpp"
+#include "kdl_export.hpp"
 
 #include <Eigen/Core>
 
@@ -21,7 +22,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverVel_pinv_givens : public ChainIkSolverVel
+    class KDL_EXPORT ChainIkSolverVel_pinv_givens : public ChainIkSolverVel
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainiksolvervel_pinv_nso.hpp b/orocos_kdl/src/chainiksolvervel_pinv_nso.hpp
index 8577024..709a90d 100644
--- a/orocos_kdl/src/chainiksolvervel_pinv_nso.hpp
+++ b/orocos_kdl/src/chainiksolvervel_pinv_nso.hpp
@@ -25,6 +25,7 @@
 #include "chainiksolver.hpp"
 #include "chainjnttojacsolver.hpp"
 #include "utilities/svd_HH.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -43,7 +44,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverVel_pinv_nso : public ChainIkSolverVel
+    class KDL_EXPORT ChainIkSolverVel_pinv_nso : public ChainIkSolverVel
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainiksolvervel_wdls.hpp b/orocos_kdl/src/chainiksolvervel_wdls.hpp
index 176e811..fa43850 100644
--- a/orocos_kdl/src/chainiksolvervel_wdls.hpp
+++ b/orocos_kdl/src/chainiksolvervel_wdls.hpp
@@ -24,6 +24,7 @@
 
 #include "chainiksolver.hpp"
 #include "chainjnttojacsolver.hpp"
+#include "kdl_export.hpp"
 #include <Eigen/Core>
 
 namespace KDL
@@ -60,7 +61,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class ChainIkSolverVel_wdls : public ChainIkSolverVel
+    class KDL_EXPORT ChainIkSolverVel_wdls : public ChainIkSolverVel
     {
     public:
         /**
diff --git a/orocos_kdl/src/chainjnttojacsolver.hpp b/orocos_kdl/src/chainjnttojacsolver.hpp
index 18e2ca5..2b92729 100644
--- a/orocos_kdl/src/chainjnttojacsolver.hpp
+++ b/orocos_kdl/src/chainjnttojacsolver.hpp
@@ -26,6 +26,7 @@
 #include "jacobian.hpp"
 #include "jntarray.hpp"
 #include "chain.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -37,7 +38,7 @@ namespace KDL
      *
      */
 
-    class ChainJntToJacSolver
+    class KDL_EXPORT ChainJntToJacSolver
     {
     public:
         explicit ChainJntToJacSolver(const Chain& chain);
diff --git a/orocos_kdl/src/frameacc.hpp b/orocos_kdl/src/frameacc.hpp
index 5d5279b..9e8e8c9 100644
--- a/orocos_kdl/src/frameacc.hpp
+++ b/orocos_kdl/src/frameacc.hpp
@@ -32,8 +32,7 @@
 
 #include "utilities/rall2d.h"
 #include "frames.hpp"
-
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -41,7 +40,7 @@ class TwistAcc;
 typedef Rall2d<double,double,double> doubleAcc;
 
 
-class VectorAcc
+class KDL_EXPORT VectorAcc
 {
 public:
     Vector p;   //!< position vector
@@ -60,37 +59,37 @@ public:
     IMETHOD static VectorAcc Zero();
     IMETHOD void ReverseSign();
     IMETHOD doubleAcc Norm();
-    IMETHOD friend VectorAcc operator + (const VectorAcc& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator - (const VectorAcc& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator + (const Vector& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator - (const Vector& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator + (const VectorAcc& r1,const Vector& r2);
-    IMETHOD friend VectorAcc operator - (const VectorAcc& r1,const Vector& r2);
-    IMETHOD friend VectorAcc operator * (const VectorAcc& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator * (const VectorAcc& r1,const Vector& r2);
-    IMETHOD friend VectorAcc operator * (const Vector& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator * (const VectorAcc& r1,double r2);
-    IMETHOD friend VectorAcc operator * (double r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator * (const doubleAcc& r1,const VectorAcc& r2);
-    IMETHOD friend VectorAcc operator * (const VectorAcc& r2,const doubleAcc& r1);
-    IMETHOD friend VectorAcc operator*(const Rotation& R,const VectorAcc& x);
-
-    IMETHOD friend VectorAcc operator / (const VectorAcc& r1,double r2);
-    IMETHOD friend VectorAcc operator / (const VectorAcc& r2,const doubleAcc& r1);
-
-
-    IMETHOD friend bool Equal(const VectorAcc& r1,const VectorAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Vector& r1,const VectorAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const VectorAcc& r1,const Vector& r2,double eps=epsilon);
-    IMETHOD friend VectorAcc operator - (const VectorAcc& r);
-    IMETHOD friend doubleAcc dot(const VectorAcc& lhs,const VectorAcc& rhs);
-    IMETHOD friend doubleAcc dot(const VectorAcc& lhs,const Vector& rhs);
-    IMETHOD friend doubleAcc dot(const Vector& lhs,const VectorAcc& rhs);
+    KDL_EXPORT IMETHOD friend VectorAcc operator + (const VectorAcc& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator - (const VectorAcc& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator + (const Vector& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator - (const Vector& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator + (const VectorAcc& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator - (const VectorAcc& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const VectorAcc& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const VectorAcc& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const Vector& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const VectorAcc& r1,double r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (double r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const doubleAcc& r1,const VectorAcc& r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator * (const VectorAcc& r2,const doubleAcc& r1);
+    KDL_EXPORT IMETHOD friend VectorAcc operator*(const Rotation& R,const VectorAcc& x);
+
+    KDL_EXPORT IMETHOD friend VectorAcc operator / (const VectorAcc& r1,double r2);
+    KDL_EXPORT IMETHOD friend VectorAcc operator / (const VectorAcc& r2,const doubleAcc& r1);
+
+
+    KDL_EXPORT IMETHOD friend bool Equal(const VectorAcc& r1,const VectorAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Vector& r1,const VectorAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const VectorAcc& r1,const Vector& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend VectorAcc operator - (const VectorAcc& r);
+    KDL_EXPORT IMETHOD friend doubleAcc dot(const VectorAcc& lhs,const VectorAcc& rhs);
+    KDL_EXPORT IMETHOD friend doubleAcc dot(const VectorAcc& lhs,const Vector& rhs);
+    KDL_EXPORT IMETHOD friend doubleAcc dot(const Vector& lhs,const VectorAcc& rhs);
 };
 
 
 
-class RotationAcc
+class KDL_EXPORT RotationAcc
 {
 public:
     Rotation R;     //!< rotation matrix
@@ -130,12 +129,12 @@ public:
     // rotvec is normalized.
     // rotation around a constant vector !
 
-    IMETHOD friend RotationAcc operator* (const RotationAcc& r1,const RotationAcc& r2);
-    IMETHOD friend RotationAcc operator* (const Rotation& r1,const RotationAcc& r2);
-    IMETHOD friend RotationAcc operator* (const RotationAcc& r1,const Rotation& r2);
-    IMETHOD friend bool Equal(const RotationAcc& r1,const RotationAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Rotation& r1,const RotationAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const RotationAcc& r1,const Rotation& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend RotationAcc operator* (const RotationAcc& r1,const RotationAcc& r2);
+    KDL_EXPORT IMETHOD friend RotationAcc operator* (const Rotation& r1,const RotationAcc& r2);
+    KDL_EXPORT IMETHOD friend RotationAcc operator* (const RotationAcc& r1,const Rotation& r2);
+    KDL_EXPORT IMETHOD friend bool Equal(const RotationAcc& r1,const RotationAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Rotation& r1,const RotationAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const RotationAcc& r1,const Rotation& r2,double eps=epsilon);
     IMETHOD TwistAcc Inverse(const TwistAcc& arg) const;
     IMETHOD TwistAcc Inverse(const Twist& arg) const;
     IMETHOD TwistAcc operator * (const TwistAcc& arg) const;
@@ -145,7 +144,7 @@ public:
 
 
 
-class FrameAcc
+class KDL_EXPORT FrameAcc
 {
 public:
     RotationAcc M;   //!< Rotation,angular velocity, and angular acceleration of frame.
@@ -168,12 +167,12 @@ public:
     IMETHOD Frame GetFrame() const;
     IMETHOD Twist GetTwist() const;
     IMETHOD Twist GetAccTwist() const;
-    IMETHOD friend FrameAcc operator * (const FrameAcc& f1,const FrameAcc& f2);
-    IMETHOD friend FrameAcc operator * (const Frame& f1,const FrameAcc& f2);
-    IMETHOD friend FrameAcc operator * (const FrameAcc& f1,const Frame& f2);
-    IMETHOD friend bool Equal(const FrameAcc& r1,const FrameAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Frame& r1,const FrameAcc& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const FrameAcc& r1,const Frame& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend FrameAcc operator * (const FrameAcc& f1,const FrameAcc& f2);
+    KDL_EXPORT IMETHOD friend FrameAcc operator * (const Frame& f1,const FrameAcc& f2);
+    KDL_EXPORT IMETHOD friend FrameAcc operator * (const FrameAcc& f1,const Frame& f2);
+    KDL_EXPORT IMETHOD friend bool Equal(const FrameAcc& r1,const FrameAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Frame& r1,const FrameAcc& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const FrameAcc& r1,const Frame& r2,double eps=epsilon);
 
     IMETHOD TwistAcc  Inverse(const TwistAcc& arg) const;
     IMETHOD TwistAcc  Inverse(const Twist& arg) const;
@@ -189,7 +188,7 @@ public:
 
 
 //very similar to Wrench class.
-class TwistAcc
+class KDL_EXPORT TwistAcc
 {
 public:
     VectorAcc vel;       //!< translational velocity and its 1st and 2nd derivative
@@ -202,19 +201,19 @@ public:
      IMETHOD TwistAcc& operator-=(const TwistAcc& arg);
      IMETHOD TwistAcc& operator+=(const TwistAcc& arg);
 
-     IMETHOD friend TwistAcc operator*(const TwistAcc& lhs,double rhs);
-     IMETHOD friend TwistAcc operator*(double lhs,const TwistAcc& rhs);
-     IMETHOD friend TwistAcc operator/(const TwistAcc& lhs,double rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator*(const TwistAcc& lhs,double rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator*(double lhs,const TwistAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator/(const TwistAcc& lhs,double rhs);
 
-     IMETHOD friend TwistAcc operator*(const TwistAcc& lhs,const doubleAcc& rhs);
-     IMETHOD friend TwistAcc operator*(const doubleAcc& lhs,const TwistAcc& rhs);
-     IMETHOD friend TwistAcc operator/(const TwistAcc& lhs,const doubleAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator*(const TwistAcc& lhs,const doubleAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator*(const doubleAcc& lhs,const TwistAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator/(const TwistAcc& lhs,const doubleAcc& rhs);
 
-     IMETHOD friend TwistAcc operator+(const TwistAcc& lhs,const TwistAcc& rhs);
-     IMETHOD friend TwistAcc operator-(const TwistAcc& lhs,const TwistAcc& rhs);
-     IMETHOD friend TwistAcc operator-(const TwistAcc& arg);
+     KDL_EXPORT IMETHOD friend TwistAcc operator+(const TwistAcc& lhs,const TwistAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator-(const TwistAcc& lhs,const TwistAcc& rhs);
+     KDL_EXPORT IMETHOD friend TwistAcc operator-(const TwistAcc& arg);
 
-     IMETHOD friend void SetToZero(TwistAcc& v);
+     KDL_EXPORT IMETHOD friend void SetToZero(TwistAcc& v);
 
      static IMETHOD TwistAcc Zero();
 
@@ -227,9 +226,9 @@ public:
      // the new point.
      // Complexity : 6M+6A
 
-     IMETHOD friend bool Equal(const TwistAcc& a,const TwistAcc& b,double eps=epsilon);
-     IMETHOD friend bool Equal(const Twist& a,const TwistAcc& b,double eps=epsilon);
-     IMETHOD friend bool Equal(const TwistAcc& a,const Twist& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const TwistAcc& a,const TwistAcc& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const Twist& a,const TwistAcc& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const TwistAcc& a,const Twist& b,double eps=epsilon);
 
 
      IMETHOD Twist GetTwist() const;
diff --git a/orocos_kdl/src/frameacc_io.hpp b/orocos_kdl/src/frameacc_io.hpp
index ee74fc7..ca229fd 100644
--- a/orocos_kdl/src/frameacc_io.hpp
+++ b/orocos_kdl/src/frameacc_io.hpp
@@ -24,28 +24,29 @@
 
 #include "frames_io.hpp"
 #include "frameacc.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
 
 // Output...
-inline std::ostream& operator << (std::ostream& os,const VectorAcc& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const VectorAcc& r) {
     os << "{" << r.p << "," << r.v << "," << r.dv << "}" << std::endl;
     return os;
 }
 
-inline std::ostream& operator << (std::ostream& os,const RotationAcc& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const RotationAcc& r) {
     os << "{" << std::endl << r.R << "," << std::endl << r.w <<
           "," << std::endl << r.dw << std::endl << "}" << std::endl;
     return os;
 }
 
 
-inline std::ostream& operator << (std::ostream& os,const FrameAcc& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const FrameAcc& r) {
     os << "{" << std::endl << r.M << "," << std::endl << r.p << "}" << std::endl;
     return os;
 }
-inline std::ostream& operator << (std::ostream& os,const TwistAcc& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const TwistAcc& r) {
     os << "{" << std::endl << r.vel << "," << std::endl << r.rot << std::endl << "}" << std::endl;
     return os;
 }
